<?php


// ======================================================================
// Gestion de l'authentification
session_name("edispatcher");
session_start();

include_once('dispatcher.config.php');

// Lib CAS
include_once('CAS/eoleCAS.php');
include_once('configCAS/cas.inc.php');

# Initialisation du client PHP
unset($_SESSION["phpCAS"]);
eolephpCAS::client(CAS_VERSION_2_0,_SERVEUR_SSO,_SERVEUR_SSO_PORT,_SERVEUR_SSO_RACINE,false);
eolephpCAS::setLang('french');
eolephpCAS::setNoCasServerValidation();
if (__CAS_DEBUG){
	eolephpCAS::setDebug('/var/log/cas-dispatcher.log');
}
eolephpCAS::EolelogoutRequests(false);

# On force l'autehntification
if (!eolephpCAS::forceAuthentication())
{
    unset($_SESSION["phpCAS"]);
    die();
}

{
    # Récupérations des attributs
    $attributs=array();
    $attributs=eolephpCAS::getDetails();

    # Stcke les variables CAS dans un tableau $_SESSION["CASATTRIBUTE"]
    $_SESSION["CASATTRIBUTE"]=array();
    foreach ($attributs as $value)
    {
        $_SESSION["CASATTRIBUTE"] += $value;
    }
    $_SESSION["id"]=uniqid('sso');
    $_SESSION["arenb"]="";
}

// ======================================================================

# Quelques fonctions utiles
include_once('fonctions.php');

# ----------------------------------------------------------------------------
# ip_in_network($ip, $net_addr, $net_mask)
# -----------------------------------------------------------------------------
# permet de determiner si $ip est dans le réseau $net_addr/$net_mask 
function ip_in_network($ip, $net_addr, $net_mask){
	if($net_mask <= 0){ return false; }
		$ip_binary_string = sprintf("%032b",ip2long($ip));
		$net_binary_string = sprintf("%032b",ip2long($net_addr));
		return (substr_compare($ip_binary_string,$net_binary_string,0,$net_mask) === 0);
}

#--------------------------------------------------------------------------
# GetPortailHost(): Récupération du portail en fonction de l'IP du client
#--------------------------------------------------------------------------
# Se base sur le fichier portails.ini
function GetPortailHost()
{
    $portail=_URL_PORTAIL_DEFAUT;
    # Si OTP, on redirige directement sur portail
    if ($portail!= "" && IsOTP())
    {
        return $portail;
    }

    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    if (isset($_SESSION["IP_CLIENT"]))
    {
        $ip=$_SESSION["IP_CLIENT"];
    }

    $les_portails=parse_ini_file("utils/portails.ini",true);

    if ($les_portails){
        foreach ($les_portails as $addr => $un_portail) {
            if (ip_in_network($ip,$addr,$un_portail['mask'])){
                $portail=$un_portail['portail'];
            }
        }
    }

    return $portail;
}
#--------------------------------------------------------------------------


/* =========================================================*/
/* Fonctions permettant d'affihcer les Applications la mode Arena*/
function Arena_BeginDomaine($TITRE)	{echo "<div id='$TITRE'><div class='col'>";}
function Arena_EndDomaine()		{echo "</div></div>";}
function Arena_SousDomaine($TITRE)	{echo "<h2>$TITRE</h2>";}
function Arena_SousSousDomaine($TITRE)	{echo "<h4>$TITRE</h4>";}

function Arena_Appli($TITRE,$URL="",$flag="",$TARGET=false)
{
	$s="";
	switch ($flag)
	{
		case "ERREUR" :$s="cross.png";$color="#F99";break;
		case "OK" :$s="check_verte.png";$color="#3A3";break;
		case "WARNING":$s="warning.png";$color="#cca12e";break;
		case "TODO":$s="todo.png";$color="#F28288";break;

	}

	if ($s != "" )
	{
		$TITRE= "<font color='$color'><img ALIGN='ABSMIDDLE' src='images/$s'>&nbsp;&nbsp;&nbsp;" . $TITRE . "</font>";
	}

	if ($URL!="")
	{
		if ($TARGET==false) echo "<h3><a href='$URL' target='_blank'><span title>$TITRE</span></a></h3>";
		else  echo "<h3><a href='$URL' target='$TARGET' ><span title>$TITRE</span></a></h3>";
	} else
	{
		echo "<h3><span title>$TITRE</span></h3>";
	}
}
/* =========================================================*/

?>
